#include "optimize.h"
#include <iostream.h>

Optimize::Optimize(Funktional &fp, double stX, double eX, double stY,
		   double eY, int saX, int saY, int i) :
  f(fp), startX(stX), endX(eX), startY(stY), endY(eY), sampleX(saX),
  sampleY(saY), interp(i), tpunkte(sampleX), rpunkte((interp+1)*(sampleX-1)+1)
{
}

Optimize::~Optimize() {
#ifdef DEBUG
  cout << "Optimize::~Optimize() aufgerufen" << endl;
#endif
}

vector<double> Optimize::solveIt(vector<double> &punkte, int ss)
{
  double ydif = (endY - startY) / (sampleY - 1);
  double tsolvn, tsolv;
  double solv = probe(punkte);
  double pki;
  int changed = 1;
  while(changed) {
    changed = 0;
#ifdef DEBUG
    cout << "while(changed)" << endl;
#endif
    for(int i = 1; i < sampleX - 1; i++){
#ifdef DEBUG
      cout << "for(auen):" << i <<endl;
#endif
      tsolvn = tsolv = solv;
      pki = punkte[i];
      for(punkte[i]+=ydif; (punkte[i]<=endY) && (tsolvn <= tsolv);
	  punkte[i]+=ydif) {
#ifdef DEBUG
	cout << "for(up)" << endl;
#endif
	tsolvn = probe(punkte);
	if(tsolvn <= tsolv) {
	  tsolv = tsolvn;
	  tpunkte = punkte;
	}
      }
      if(tsolv < solv) {
	solv = tsolv;
	punkte = tpunkte;
	changed = ss;
#ifdef DEBUG
	cout << "UP" << endl;
#endif
      } else {
	tsolvn = solv;
	for(punkte[i]=pki-ydif; (punkte[i]>=startY) && (tsolvn <= tsolv);
	    punkte[i]-=ydif) {
#ifdef DEBUG
	  cout << "for(down)" << endl;
#endif
	  tsolvn = probe(punkte);
	  if(tsolvn <= tsolv) {
	    tsolv = tsolvn;
	    tpunkte = punkte;
	  }
	}
	if(tsolv < solv) {
	  solv = tsolv;
	  punkte = tpunkte;
	  changed = ss;
	} else {
	  punkte[i] = pki;
	}
      }
    }
  }
  return punkte;
}
  
double Optimize::probe(vector<double> &punkte){
#ifdef DEBUG
  cout << "rpunkte.size()=" << rpunkte.size() << "; maxv = "
       << (sampleX - 2)*(interp+1)+interp << endl;
#endif
  for(int i=0; i < sampleX-1; i++){
    for(int j=0; j<=interp; j++)
      rpunkte[j+(interp+1)*i] = ((interp+1-j)*punkte[i] + j*punkte[i+1]) /
	double(interp+1);
  }
  rpunkte[rpunkte.size()-1] = punkte[sampleX-1];
  double tmp = f.execute(startX, endX, rpunkte);
#ifdef DEBUG
  cout << "Optimize::probe: " << tmp << endl;
  cout << "Punkte: " << punkte[0] << "," << punkte[1] << ","
       << punkte[2] << "," << punkte[3] << "," << punkte[4] << endl;
#endif
  return tmp;
}
