#ifndef OPTIMIZE_H
#define OPTIMIZE_H

#include "solver.h"
#include "funktional.h"

class Optimize: public solver {
public:
  Optimize(Funktional &f, double startX, double endX, double startY,
	   double endY, int sampleX, int sampleY, int interp);
  ~Optimize();
  vector<double> solve(vector<double> &punkte){
    return solveIt(punkte, 1);
  }
  vector<double> solveIt(vector<double> &punkte, int ss);
  
protected:
  Optimize();
  Optimize (const Optimize &);
private:
  double probe(vector<double> &punkte);

  Funktional &f;
  double startX, endX, startY, endY;
  int sampleX, sampleY, interp;
  vector<double> tpunkte;
  vector<double> rpunkte;
};

class OptimizeSS: public Optimize {
public:
  OptimizeSS(Funktional &f, double startX, double endX, double startY,
	     double endY, int sampleX, int sampleY, int interp):
    Optimize(f, startX, endX, startY, endY, sampleX, sampleY,
	     interp){};
  vector<double> solve(vector<double> &punkte){
    return solveIt(punkte, 0);
  }
  
private:
  OptimizeSS();
  OptimizeSS (const Optimize &);
};

#endif
