#include "probiere.h"
#include <iostream.h>

Probiere::Probiere(Funktional &fp, double stX, double eX, double stY,
		   double eY, int saX, int saY, int i):
  f(fp), startX(stX), endX(eX), startY(stY), endY(eY), sampleX(saX),
  sampleY(saY), interp(i), tpunkte((interp+1)*(sampleX-1)+1)
{
}

vector<double> Probiere::solve(vector<double> &punkte)
{
  vector<double> sol(punkte.size(), startY);
  fill(punkte.begin() + 1, punkte.end() - 1,startY);

  double solv = probe(punkte);
  double ydif = (endY - startY) / (sampleY - 1);
  sol = punkte;
  double tsolv;
  for(;;) {
    int j = 1;
    while((j < sampleX - 1) && ((punkte[j] += ydif) > endY))
      punkte[j++] = startY;
    if(j >= sampleX - 1)
      break;
    if((tsolv = probe(punkte)) < solv) {
      solv = tsolv;
      sol = punkte;
    }
  }
#ifdef DEBUG
  cout << "solv: " << solv << endl;
#endif
  return sol;
}
  
double Probiere::probe(vector<double> &punkte){
  for(int i=0; i < int(punkte.size())-1; i++){
    for(int j=0; j<(interp+1); j++)
      tpunkte[j+(interp+1)*i] = double((interp-j+1)*punkte[i]+j*punkte[i+1]) /
	double(interp+1);
  }
  tpunkte[tpunkte.size()-1] = punkte[punkte.size()-1];
  double tmp = f.execute(startX, endX, tpunkte);
#ifdef DEBUG
  cout << "Probiere::probe: " << tmp << endl;
  cout << "Punkte: " << punkte[0] << "," << punkte[1] << ","
       << punkte[2] << "," << punkte[3] << "," << punkte[4] << endl;
#endif
  return tmp;
}
