%{
#include <stdlib.h>

/* ******************************************************************** */

int old_parse_char = -1;

#define YY_INPUT(buf,result,max_size) { \
        unsigned char rvalue = 0; \
        if (old_parse_char != -1) { \
                rvalue = old_parse_char; \
                old_parse_char = -1; \
        } else { \
                unsigned char* p = parse_string; \
                rvalue = *p; \
                if (rvalue) { p++; parse_position++; }; \
                parse_string = p; \
        } \
        result = (rvalue == 0) ? YY_NULL : (buf[0] = rvalue, 1); \
}


%}

%option noyywrap

ziffern  ([0-9]+)
zahl     (({ziffern}?[.]{ziffern})|({ziffern}[.]?))

%%

[ \t\n\r]+   ; /* Leer- und Tabzeichen ueberlesen */
"\0"     { return(ZEILENENDE); }
{zahl}   { yylval.reel = strtod(yytext,NULL); return(ZAHL); }
"+"      { return(PLUS); }
"-"      { return(MINUS); }
"**"     { return(HOCH); }
"*"      { return(MULT); }
"/"      { return(DIV); }
"("      { return(KLAMMERAUF); }
")"      { return(KLAMMERZU); }
"^"      { return(HOCH); }
"sin"    { return(SINUS); }
"cos"    { return(COSINUS); }
"tan"    { return(TANGENTS); }
"exp"    { return(EXP); }
"ln"     { return(LN); }
"sqrt"   { return(SQRT); }
"abs"    { return(ABS); }
"brachistochrone" { return(BRACHISTOCHRONE); }
"gerade" { return(GERADE); }
"seifenhaut" { return(SEIFENHAUT); }
"x"      { return(VARX); }
"y"      { return(Y); }
"y'"     { return(DY); }
.        { yylval.reel = yytext[0]; return(NICHTS); }
%%
