%{
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

Funktional* scanned_funktional;
#define f scanned_funktional
unsigned char * parse_string = NULL;
unsigned int parse_position = 0;
char * parse_error = NULL;

char error_buf[100];

void yyerror(char* str) {
	snprintf(error_buf, 100, "Char [%d]: %s", parse_position, str);
	parse_error = error_buf;
}

int yylex();
%}

%union {
        double  reel;
        int     zeiger;
	int     dummy;
}

%start zeilen
%token <dummy> PLUS MINUS MULT DIV KLAMMERAUF KLAMMERZU HOCH
%token <dummy> VARX Y DY
%token <reel>  ZAHL 
%token <dummy> ZEILENENDE NICHTS
%token <dummy> BRACHISTOCHRONE GERADE SEIFENHAUT
%token <dummy> SINUS COSINUS TANGENTS EXP LN SQRT ABS

%type  <zeiger> ausdruck term faktor potenz funktion zeilen
%%

zeilen :   ausdruck
       |   error { yyclearin; yyerrok; f->initialize(); }
       ;

ausdruck:  ausdruck PLUS term { $$ = f->additem(new fi_add($1,$3)); }
        |  ausdruck MINUS term { $$ = f->additem(new fi_sub($1,$3)); }
        |  term { $$ = $1; }
        ;

term    :  term MULT faktor { $$ = f->additem(new fi_mul($1,$3)); }
        |  term DIV  faktor { $$ = f->additem(new fi_div($1,$3)); }
        |  faktor { $$ = $1; }
        ;

faktor  :  funktion { $$ = $1; }
        |  MINUS funktion { $$ = f->additem(new fi_minus($2)); }
        |  ZAHL { $$ = f->additem(new fi_konst($1)); }
        |  MINUS ZAHL { $$ = f->additem(new fi_konst(-$2)); }
        |  potenz { $$ = $1; }
        |  MINUS potenz { $$ = f->additem(new fi_minus($2)); }
        ;

potenz  :  ZAHL HOCH faktor { 
	        $$ = f->additem(new fi_pow(f->additem(new fi_konst($1)), $3)); 
        }
        |  funktion HOCH faktor {
		$$ = f->additem(new fi_pow($1, $3));
	}
        |  KLAMMERAUF ausdruck KLAMMERZU HOCH faktor { 
		$$ = f->additem(new fi_pow($2, $5)); }
        |  KLAMMERAUF ausdruck KLAMMERZU { $$ = $2; }
        ;

funktion:  SINUS KLAMMERAUF ausdruck KLAMMERZU { 
	        $$ = f->additem(new fi_sin($3)); }
        |  COSINUS KLAMMERAUF ausdruck KLAMMERZU { 
		$$ = f->additem(new fi_cos($3)); }
        |  TANGENTS KLAMMERAUF ausdruck KLAMMERZU { 
		$$ = f->additem(new fi_tan($3)); }
        |  LN KLAMMERAUF ausdruck KLAMMERZU { 
		$$ = f->additem(new fi_ln($3)); }
        |  EXP KLAMMERAUF ausdruck KLAMMERZU { 
		$$ = f->additem(new fi_exp($3)); }
        |  SQRT KLAMMERAUF ausdruck KLAMMERZU { 
		$$ = f->additem(new fi_sqrt($3)); }
        |  ABS KLAMMERAUF ausdruck KLAMMERZU { 
		$$ = f->additem(new fi_abs($3)); }
        |  VARX { $$ = f->additem(new fi_varx()); }
        |  Y KLAMMERAUF ausdruck KLAMMERZU { 
		$$ = f->additem(new fi_y($3)); }
        |  DY KLAMMERAUF ausdruck KLAMMERZU { 
		$$ = f->additem(new fi_dy($3)); }
        |  BRACHISTOCHRONE KLAMMERAUF KLAMMERZU { 
		$$ = f->additem(new fi_brachistochrone()); }
        |  GERADE KLAMMERAUF KLAMMERZU { 
		$$ = f->additem(new fi_gerade()); }
        |  SEIFENHAUT KLAMMERAUF KLAMMERZU { 
		$$ = f->additem(new fi_seifenhaut()); }
        ;

%%

#include "lex.yy.c"
