#include "funktional.h"
#include "probiere.h"
#include "optimize.h"
#include "iostream.h"

char* execSolve(char *fs, double startX, double endX, double startY,
		double endY, int sampleX, int sampleY,
		vector<double> &punkte, int solveType, int interp)
{
  Funktional f;
#ifdef DEBUG
  cout << "Start von execSolve" << endl;
#endif
  char* c = f.parse(fs);
  if (c) {
    return c;
  }
  switch (solveType) {
  case 0: {
#ifdef DEBUG
    cout << "Start von Probiere::solve" << endl;
#endif
    Probiere pro(f, startX, endX, startY, endY, sampleX, sampleY, interp);
    punkte = pro.solve(punkte);
    break;}
  case 1: {
#ifdef DEBUG
    cout << "Start von Optimize::solve" << endl;
#endif
    Optimize opt(f, startX, endX, startY, endY, sampleX, sampleY, interp);
    punkte = opt.solve(punkte);
    break;}
  case 2: {
#ifdef DEBUG
    cout << "Start von OptimizeSS::solve (single-step)" << endl;
#endif
    OptimizeSS opt(f, startX, endX, startY, endY, sampleX, sampleY, interp);
    punkte = opt.solve(punkte);
    break;}
  default:
    break;
  }
#ifdef DEBUG
  cout << " Ende von execSolve" << endl;
#endif
  return NULL;
}
